package gui.settings;

import java.awt.Component;

import javax.swing.JSplitPane;

import settings.Settings;
import settings.SettingsLoadable;

public class SettingsSplitPane extends JSplitPane implements SettingsLoadable {

	private static final long serialVersionUID = -7625376396852597410L;

	private String settingsName;

	private void setSettingsName(String settingsName) {
		this.settingsName = settingsName;
	}
	
	public SettingsSplitPane(String settingsName) {
		setSettingsName(settingsName);
	}

	public SettingsSplitPane(int orientation, String settingsName) {
		super(orientation);
		setSettingsName(settingsName);
	}

	public SettingsSplitPane(int orientation, Component left, Component right, String settingsName) {
		super(orientation, left, right);
		setSettingsName(settingsName);
	}

	public SettingsSplitPane(int newOrientation, boolean newContinuousLayout, Component newLeftComponent, Component newRightComponent, String settingsName) {
		super(newOrientation, newContinuousLayout, newLeftComponent, newRightComponent);
		setSettingsName(settingsName);
	}

	@Override
	public void loadSettings(Settings s) {
		System.out.println(settingsName);
		setDividerLocation(s.getInt(settingsName+"Divider"));
	}

	@Override
	public void saveSettings(Settings s) {
		s.set(settingsName+"Divider", getDividerLocation());
	}
}
