/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.settings.dialog.component;

import settings.Settings;

public class UnsignedIntComponent extends TextSettingsComponent {

	public UnsignedIntComponent(String text,String settingsName) {
		super(text, settingsName);
	}

	@Override
	public void saveSettings(Settings s) {
		if (txt.getText().length()>0) {
			try {
				s.set(settingsName, Integer.parseInt(txt.getText()));
			} catch (NumberFormatException e) {
				
			}
		}
	}

	@Override
	public void loadSettings(Settings s) {
		int i=s.getInt(settingsName);
		if (i>0) txt.setText(Integer.toString(i));
	}

}
