/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package model.transfer;

public class TransferInfo {
	protected long currentBytes,prevBytes;
//	protected LinkedList<Long> bytesHistory;
	protected Status status;
	protected Exception error;
	protected int id,tries;
	protected boolean lockCancel;
	
	public TransferInfo() {
//		bytesHistory=new LinkedList<>();
	}
	
	public int getId() {
		return id;
	}
	
	protected void setId(int id) {
		this.id = id;
	}
	
	public Status getStatus() {
		return status;
	}

	void setStatus(Status s) {
		if (!lockCancel) {
			if (status!=Status.finished) {
				this.status=s;
			}
		}else if (this.status!=Status.stopped){
			this.status=Status.stopped;
		}
	}
	
	public void setLockCancel(boolean lockCancel) {
		this.lockCancel = lockCancel;
	}
	
	public synchronized void updateBytes(long bytes) {
		
		prevBytes=currentBytes;
		currentBytes = bytes;
//		bytesHistory.add(bytes-prevBytes);
//		if (bytesHistory.size()>8) bytesHistory.remove(0);
		
	}
		
	public synchronized long getCurrentBytes() {
		return currentBytes;
		
	}
	
	public synchronized long getSpeed() {
		/*long speed=0L;
		if (bytesHistory.size()>0) {
			for (long l:bytesHistory) {
				speed+=l;
			}
			return speed/bytesHistory.size();
		} else {
			return 0L;
		}*/
		return currentBytes-prevBytes;
	}
	
	public void setError(Exception e) {
		this.error=e;
	}
	
	public Exception getError() {
		return error;
	}

	public void nextTry() {		
		tries++;
		System.out.println("Next try: "+tries);
	}

	public int getTries() {
		return tries;
	}
	
	public void reset() {
		currentBytes=0;
		prevBytes=0;
//		bytesHistory.clear();
		error=null;
	}
	
}

