/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package shoshone.httpclient;

import java.io.IOException;

import util.exception.CancelException;

public abstract class Multipart {
	
	protected String fieldName,boundary;
	
	protected Shoshone urlConn;
	
	public static final String CONTENT_DISP = "Content-Disposition: form-data; name=\"";
	   
	public static final char QUOTE ='"';
	
	public static final String PREFIX="--"; 
	
	public Multipart(Shoshone urlConn,String fieldName) {
		this.urlConn=urlConn;
		this.fieldName= fieldName;
	}
	
	public abstract long getContentLength() throws IOException;
	
	public void setBoundary(String boundary) {
		this.boundary=boundary;
	}
	
	public abstract void apply() throws IOException, CancelException;
}
