/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package util.base64;

import java.util.Map;
import java.util.TreeMap;

public class Base64Decoder {
	
	public static final Map<Character,Byte> chars;
	static {
		chars = new TreeMap<>();
		chars.put('A',(byte)0);
		chars.put('B',(byte)1);
		chars.put('C',(byte)2);
		chars.put('D',(byte)3);
		chars.put('E',(byte)4);
		chars.put('F',(byte)5);
		chars.put('G',(byte)6);
		chars.put('H',(byte)7);
		chars.put('I',(byte)8);
		chars.put('J',(byte)9);
		chars.put('K',(byte)10);
		chars.put('L',(byte)11);
		chars.put('M',(byte)12);
		chars.put('N',(byte)13);
		chars.put('O',(byte)14);
		chars.put('P',(byte)15);
		chars.put('Q',(byte)16);
		chars.put('R',(byte)17);
		chars.put('S',(byte)18);
		chars.put('T',(byte)19);
		chars.put('U',(byte)20);
		chars.put('V',(byte)21);
		chars.put('W',(byte)22);
		chars.put('X',(byte)23);
		chars.put('Y',(byte)24);
		chars.put('Z',(byte)25);
		chars.put('a',(byte)26);
		chars.put('b',(byte)27);
		chars.put('c',(byte)28);
		chars.put('d',(byte)29);
		chars.put('e',(byte)30);
		chars.put('f',(byte)31);
		chars.put('g',(byte)32);
		chars.put('h',(byte)33);
		chars.put('i',(byte)34);
		chars.put('j',(byte)35);
		chars.put('k',(byte)36);
		chars.put('l',(byte)37);
		chars.put('m',(byte)38);
		chars.put('n',(byte)39);
		chars.put('o',(byte)40);
		chars.put('p',(byte)41);
		chars.put('q',(byte)42);
		chars.put('r',(byte)43);
		chars.put('s',(byte)44);
		chars.put('t',(byte)45);
		chars.put('u',(byte)46);
		chars.put('v',(byte)47);
		chars.put('w',(byte)48);
		chars.put('x',(byte)49);
		chars.put('y',(byte)50);
		chars.put('z',(byte)51);
		chars.put('0',(byte)52);
		chars.put('1',(byte)53);
		chars.put('2',(byte)54);
		chars.put('3',(byte)55);
		chars.put('4',(byte)56);
		chars.put('5',(byte)57);
		chars.put('6',(byte)58);
		chars.put('7',(byte)59);
		chars.put('8',(byte)60);
		chars.put('9',(byte)61);
		chars.put('+',(byte)62);
		chars.put('/',(byte)63);
		chars.put('=',(byte) 0);
	}
	
	public static byte[] decode(String base64) {
		byte[] bytes=new byte[base64.length()*3/4];
		final char NEW_LINE='\n',CR='\r';
		int k=0,i=0;
		//for (int i=0;i<base64.length();i+=4) {
		while (i<base64.length()) {
			char c;
			
			do{
				c= base64.charAt(i++);
			} while (c==NEW_LINE||c==CR);
			long l=chars.get(c);
			
			do{
				c= base64.charAt(i++);
			} while (c==NEW_LINE||c==CR);
			l=l<<6|chars.get(c);
			
			do{
				c= base64.charAt(i++);
			} while (c==NEW_LINE||c==CR);
			l=l<<6|chars.get(c);
			
			do{
				c= base64.charAt(i++);
			} while (c==NEW_LINE||c==CR);
			l=l<<6|chars.get(c);
			
			byte b1=(byte)( (l&0xff0000)>>16);
			byte b2=(byte)( (l&0xff00)>>8);
			byte b3=(byte) (l&0xff);
			
			bytes[k++]=b1;
			bytes[k++]=b2;
			bytes[k++]=b3;
		}
		
		if (base64.endsWith("=="))
			k-=2; 
		else if (base64.endsWith("="))
			 k--;
		
		byte[] ret=new byte[k];
		System.arraycopy(bytes, 0, ret, 0, k);
		return ret;
	}
}
